/*************************************************************************

 pfcave.h

  Header for pfCAVE library version 2.2  (part of version 2.6 of the CAVE
 libraries).

**************************************************************************/

#ifndef __PFCAVE_H__
#define __PFCAVE_H__

#ifndef IRISGL
#ifndef OPENGL
#define OPENGL
#endif
#endif

#include <Performer/pf.h>
#include <cave.h>

#ifdef __cplusplus
extern "C" {
#endif

extern void pfCAVEConfig(int *argc, char **argv, char **appdefaults);
                                         /* call just before pfConfig() */
extern void pfCAVEInitChannels(void);    /* call to create channels */
extern void pfCAVEPreFrame(void);        /* call once/frame before pfFrame() */
					 /* copies tracker info and sets channels */
extern void pfCAVEPostFrame(void);       /* call once/frame after pfFrame() */

extern void pfCAVEDrawFunc(pfChanFuncType func);
extern void pfCAVEPreDrawFunc(pfChanFuncType func);
extern void pfCAVEPostDrawFunc(pfChanFuncType func);
extern pfChannel * pfCAVEMasterChan(void);
extern pfList * pfCAVEChannels(void);
extern pfList * pfCAVEPipes(void);
extern void pfCAVEHalt(void);

extern void pfCAVEDCSHeadTransform(pfDCS *dcs);
extern void pfCAVEDCSWandTransform(pfDCS *dcs);
extern void pfCAVEDCSSensorTransform(pfDCS *dcs,CAVE_SENSOR_ST *sensor);
extern void pfCAVEHeadTransform(void);
extern void pfCAVEWandTransform(void);
extern void pfCAVESensorTransform(CAVE_SENSOR_ST *sensor);
extern void pfCAVEDCSNetHeadTransform(pfDCS *dcs,volatile CAVE_USER_ST *user);
extern void pfCAVEDCSNetWandTransform(pfDCS *dcs,volatile CAVE_USER_ST *user);
extern void pfCAVENetHeadTransform(volatile CAVE_USER_ST *user);
extern void pfCAVENetWandTransform(volatile CAVE_USER_ST *user);
extern void pfCAVEDCSNavTransform(pfDCS *dcs);


extern char *pfCAVEVersion;


/* Note: the following functions are unnecessary; they are only included for
	backwards compatibility.  New applications should just call the corresponding
	CAVE functions (i.e. CAVEGetPosition(), etc.) directly.	*/
extern void pfCAVEGetPosition(CAVEID id,float *pos);
extern void pfCAVEGetVector(CAVEID id,float *vec);
extern void pfCAVEGetOrientation(CAVEID id,float *ori);
extern void pfCAVEGetSensorPosition(CAVE_SENSOR_ST *sensor,CAVEID coords,float *pos);
extern void pfCAVEGetSensorVector(CAVE_SENSOR_ST *sensor,CAVEID id,float *vec);
extern void pfCAVEGetSensorOrientation(CAVE_SENSOR_ST *sensor,CAVEID coords,float *ori);
extern void pfCAVENetGetPosition(volatile CAVE_USER_ST *user,CAVEID id,float *pos);
extern void pfCAVENetGetVector(volatile CAVE_USER_ST *user,CAVEID id,float *vec);
extern void pfCAVENetGetOrientation(volatile CAVE_USER_ST *user,CAVEID id,float *ori);


#ifdef __cplusplus
}
#endif

#endif
